routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Route::group(['middleware' => 'auth'],function (){
    Route::get('/', function () {
        return view('dashboard.index');
    });

    Route::get('/dashboard','DashboardController@index')->name('dashboard');
    Route::resource('post','PostController');
    Route::resource('message','MessageController');
    Route::resource('comment','CommentController');


});

Auth::routes();

Route::get('/cl',function (){
    Artisan::call('view:clear');
    Artisan::call('route:clear');
    Artisan::call('cache:clear');
    Artisan::call('config:cache');
    return 'cache cleared';
});

app/Message.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Message extends Model
{
    protected $table = 'messages';
    protected $fillable = ['from_user','to_user','message_body'];


    public function user(){
        return $this->belongsTo(User::class,'to_user');
    }



}

app/Http/Controllers/DashboardController.php
<?php

namespace App\Http\Controllers;

use App\Post;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;

class DashboardController extends Controller
{


    public function index(){

        $posts = Post::with(['user','comment'])->get();
//        return $posts;die();

        Log::info($posts);
        return view('dashboard.index',compact('posts'));
    }
}

app/Http/Controllers/MessageController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\MessageStoreRequest;
use App\Message;
use App\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class MessageController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $users = User::all()->except(Auth::user()->id);

        return view('dashboard.message.index',compact('users'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(MessageStoreRequest $request)
    {
        $message = Message::create([
            'from_user' => Auth::user()->id,
            'to_user' => $request->to_user,
            'message_body' => $request->message_body
        ]);

        return redirect()->back();

    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Message  $message
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {

        $messages =  Message::with('user')->where(['to_user' => $id, 'from_user' => Auth::user()->id])->orderBy('created_at','desc')->get();

//        return $messages;die();

        return view('dashboard.message.chat',compact('messages'));


    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Message  $message
     * @return \Illuminate\Http\Response
     */
    public function edit(Message $message)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Message  $message
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Message $message)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Message  $message
     * @return \Illuminate\Http\Response
     */
    public function destroy(Message $message)
    {
        //
    }
}

resources/views/dashboard/message/chat.blade.php
@extends('layouts.backend')

@section('content')
    <h2>Messages</h2>
{{--    <label for=""> Recipent : {{$messages['to_user')}}</label>--}}


    <table class="table">
        <tr>
            <td>Date</td>
            <td>Recipent</td>
            <td>Message</td>
            <td>Actions</td>
        </tr>


        @if(isset($messages) && count($messages) > 0 )
            @foreach($messages as $m)
                <tr>
                    <td>{{$m->created_at}}</td>
                    <td>{{$m->user->name}}</td>
                    <td>{{$m->message_body}}</td>
                    <td>
                        <button>Del</button>
                    </td>
                </tr>
            @endforeach
        @endif


    </table>



@endsection

resources/views/dashboard/message/create.blade.php
@extends('layouts.backend')

@section('content')

    <h2>post create</h2>

@endsection

resources/views/dashboard/message/edit.blade.php
@extends('layouts.backend')

@section('content')

    <h2>post edit</h2>

@endsection

resources/views/dashboard/message/index.blade.php
@extends('layouts.backend')

@section('content')

   <div class="row">

           @if(isset($users) && count($users) > 0)
               @foreach($users as $user)
               <div class="col-3">

                   <object data="{{asset('images/users/'.$user->picture)}}" type="image/png">
                       <img src="{{asset('images/avatar/person.png')}}" alt="no image" width="50px">
                   </object>


                   <form method="post" action="{{route('message.store')}}">
                       @csrf
                       <input type="hidden" name="to_user" value="{{$user->id}}">
                       <label class="d-block" for="">Name : {{$user->name}}</label>
                       <textarea name="message_body" id="message_body" cols="20" rows="2" placeholder="write here"></textarea>
                       <button type="submit">Quick Msg</button>
                       <a class="btn btn-secondary" href="{{route('message.show',$user->id)}}">Msgs</a>
                   </form>
               </div>

               @endforeach

               @else
               <h4>No Users</h4>

            @endif



   </div>

@endsection